#!/usr/bin/perl

$SYNOP="csvSpk2qif
Homepage: http://www.henning-mersch.de/projects
Author: Henning Mersch <mail\@henning-mersch.de>
License: GPLv2

Convert a Sparkasse generated CSV file to a QIF like used
by Grisbi ( http://www.gribi.org )

%> csvSpk2qif.pl INFILE > OUTFILE
";

if(!$ARGV[0]) {
  print STDERR $SYNOP;
  exit;
}


print "!Type:Bank\n^\n";

while (<>) {
   # "25628520";"15.11"       ;"15.       11.     05";"GELDAU";"15.1";"GA N";"    ";"3905";"-15,0";"EUR";"Umsatz vorgemerkt"
   #                1             2        3      4       5      6       7     8      9      10      11    12
   if (m/"\d+";"(\d\d\.\d\d)";"(\d\d)\.(\d\d)\.(\d\d)";"(.*)";"(.*)";"(.*)";"(.*)";"(.*)";"(.*)";"(.*)";"(.*)"/) {
   #   "Auftragskonto";
   #1: "Buchungstag";
   #2/3/4: "Valutadatum"     -> D;
   $d = "$2/$3/20$4";
   #5: "Buchungstext";       -> M1;
   #6: "Verwendungszweck"    -> M2;
   $m = "$5: $6";
   #7: "Begünstigter/Zahlungspflichtiger"   -> P;
   #8: "Begünstigter-Kontonummer"           -> P;
   #9: "Begünstigter-BLZ";                  -> P;
   $p = "$7 ($8/$9)";
   #10:"Betrag"              -> T;
   $t = "$10";
   $t =~ s/\.//; #elem dot in "1.000,00" 
   #11:"Währung";
   #12:"Info"
   print "D$d\nM$m\nP$p\nT$t\n^\n";
   } else {
	 print STDERR "unparseable Line found: $_";
   }
}
